<template>
  <ThemeCommonMobileMainPageWrapper
    :hide-title="!isShowHeader"
    :title="$t('messages')"
  >
    <ThemeCommonMobileMainTabs
      v-model="activeTab"
      class="message-tabs"
      :navigator="false"
    >
      <el-tab-pane
        v-for="(tab, index) in tabs"
        :key="`tab-${index}`"
        :name="tab"
        :label="$t(tab)"
        :disabled="isLoading"
        class="py-2"
      >
        <template #label>
          <div class="flex items-center">
            {{ $t(tab) }}
            <MessagesMessageCount
              :count="unreadInfo[EnumUnreadInfoMapper[tab]]"
              :is-unread="tab === 'Unread'"
            />
          </div>
        </template>
        <div v-if="activeTab === tab" class="w-full message-actions bg-2 z-1">
          <div class="flex gap-2 items-center p-2">
            <el-button
              class="h-8 w-full !p-2 message-batch-action-btn bg-background5"
              :disabled="!messages.length"
              :loading="isUpdatingStatus === 'MarkAllRead' || isLoading"
              @click="onMarkAllRead"
            >
              <div class="flex items-center">
                <IMessageOpen
                  v-if="isUpdatingStatus !== 'MarkAllRead' && !isLoading"
                  class="w-4 h-4 mr-1"
                />
                {{ $t("Marked all read") }}
              </div>
            </el-button>
            <div class="message-batch-action-divider ol-bg-dark-2"></div>
            <el-button
              class="h-8 w-full !p-2 message-batch-action-btn delete-btn bg-background5"
              :disabled="!messages.length"
              :loading="isUpdatingStatus === 'DeleteAll' || isLoading"
              @click="onOpenDeleteConfirmation(true)"
            >
              <div class="flex items-center">
                <ITrash
                  v-if="isUpdatingStatus !== 'DeleteAll' && !isLoading"
                  class="w-4 h-4 mr-1"
                />
                {{ $t("Delete all") }}
              </div>
            </el-button>
          </div>
        </div>
        <MobileMessagesMessageItemWrapper
          :messages="messages"
          :is-loading="isLoading"
          :is-loading-more="isLoadingMore"
          @item:click="onMessageClicked"
          @item:delete="onOpenDeleteConfirmation"
          @loadmore="onLoadMoreMessages"
        />
      </el-tab-pane>
    </ThemeCommonMobileMainTabs>
  </ThemeCommonMobileMainPageWrapper>
  <MessagesPreviewMessageDialog
    v-model="isShowPreviewMessageDialog"
    :message="messageDetail"
    @click:delete="onOpenDeleteConfirmation(messageDetail)"
  />
  <MessagesDeleteDialog
    v-model="isShowDeleteDialog"
    :is-delete-all="!messageDetail"
    :is-loading="
      isLoading ||
      isUpdatingStatus === 'DeleteAll' ||
      isUpdatingStatus === 'SingleDelete'
    "
    @click:delete="onConfirmDelete"
  />
</template>

<script setup lang="ts">
import { useMessage } from "~~/composables/useMessage";
import { EnumUnreadInfoMapper } from "~~/models/enums/enumMessage";
import IMessageOpen from "~/assets/icons/message-open.svg?component";
import ITrash from "~/assets/icons/trash.svg?component";
import { store } from "~~/store";
import { memberMessageStore } from "~~/store/member-message";
import EnumMutation from "~~/models/enums/enumMutation";

const arrayTheme = ["main", "black", "sbo", "global", "playful", "peru"];
const isShowHeader = computed(() =>
  arrayTheme.includes(store.state.selectedThemeName)
);
const {
  isUpdatingStatus,
  messageDetail,
  isLoadingMore,
  isShowDeleteDialog,
  isShowPreviewMessageDialog,
  pagination,
  isLoading,
  tabs,
  activeTab,
  isLoadMore,
  messages,
  unreadInfo,
  fetchMessages,
  onMessageClicked,
  onOpenDeleteConfirmation,
  onMarkAllRead,
  onConfirmDelete,
  onLoadMoreMessages,
} = useMessage();

watch(
  activeTab,
  () => {
    pagination.value.CurrentPage = 1;
    isLoadMore.value = false;
    memberMessageStore.commit(EnumMutation.updateActiveTab, activeTab.value);
    fetchMessages();
  },
  {
    immediate: true,
  }
);

onMounted(() => {
  activeTab.value = "Unread";
});
</script>

<style lang="scss">
[data-device="mobile"] {
  .member-message-tab {
    .el-tabs__nav-wrap {
      padding-left: 8px;
      padding-right: 8px;
    }
    .el-tabs__item {
      height: 40px;

      & > div {
        height: 40px;
      }
    }
    .el-tabs__nav-next,
    .el-tabs__nav-prev {
      display: none;
    }
    .el-tabs__nav-scroll {
      overflow-x: scroll;
      scrollbar-color: transparent transparent !important;
    }
    .el-button.is-disabled {
      --el-button-disabled-bg-color: var(--background5);
    }
  }
  .el-overlay {
    background-color: rgba(0, 0, 0, 0.5);
  }
}
.message-pagination.el-pagination {
  --el-pagination-bg-color: transparent;
  --el-pagination-text-color: var(--text5);
  --el-pagination-hover-color: var(--primary);
  --el-pagination-button-color: var(--text5);

  & > .el-pager {
    li {
      border-radius: 4px;
      &.is-active {
        border: 2px solid var(--primary);
        box-sizing: border-box;
      }
    }
  }
  & > button {
    &,
    &:disabled {
      background-color: transparent;
      height: 32px;
      color: var(--text5);
    }
  }
}

.message-batch-action-btn.el-button {
  color: var(--primary);
  --el-button-border-color: var(--background5);
  &.delete-btn {
    color: var(--failure);
  }
  &,
  svg {
    fill: currentColor !important;
    stroke: unset !important;
  }
}

.message-batch-action-divider {
  --bg-base-color: var(--border);
  --bg-opacity: 0.3;

  width: 1px;
  height: 16px;
}

.message-action-button.el-button {
  --bg-opacity: 0.15;
  --bg-base-color: var(--background5);

  height: 30px;
  border-radius: 8px;
  color: var(--text5) !important;
  background-color: transparent;
  background-image: unset;
  border: none;
}
</style>
